//James McCartney's updated version
Array2D : Collection {
    var <rows, <cols, <array;
    *new { arg rows=1, cols=1;
        ^super.new.init(Array.newClear(rows*cols), rows, cols)
    }
    *newClear { arg rows=1, cols=1;
        ^this.new(rows, cols);
    }
    init { arg argArray, argRows, argCols;
        array = argArray;
        rows = argRows;
        cols = argCols;
    }
    
    at { arg row, col;
        ^array.at(row*cols + col)
    }
    put { arg row, col, val;
        array.put(row*cols + col, val)
    }
    do { arg func;
        array.do(func)
    }
    
}