//Array2D that sets and gets ControlValues
//see also: extArray2D. 
//tried to simplify further, no success though.

ControlArray2D : Array2D {
	var <>array2D;
	*new { arg rows, cols, spec, synthID, controlID = 0, initialValue;
			^super.new(rows, cols).makeControls(synthID, spec, initialValue, controlID)
	}
	
	makeControls { arg synthID, spec, initialValue, controlID;

			array2D = Array2D.fill(rows, cols, { arg row, col;
				var plugID;
					plugID = ((row*cols + col).asString ++ controlID).asSymbol; //each one a special id
					ControlValue.new(spec ? \unipolar, synthID, plugID, initialValue ?? ControlSpace.at(synthID,plugID))
				});
			
			
			/*
			rows.do({ arg row;
				cols.do({ arg col;
					var plugID;
					plugID = row*cols + col;
					array.put(plugID, 
						ControlValue.new(spec ? \unipolar, synthID, plugID, initialValue ?? ControlSpace.at(synthID,plugID))
					)
				})
			});
			*/
			
			
	}
	removeControls {
		ControlSpace.removeAt(this.synthID)
	}
	
	at { arg row, col;
		^this.get(row, col);
	}
	
	put { arg row, col, val;
		this.set(row, col, val)
	}
	
	set { arg row, col, val;
		array2D.at(row, col).set(val)
	} 
	
	get { arg row, col, prevVal;
		^array2D.at(row, col).get(prevVal)
	}
	
	getMapped { arg row, col;
		^array2D.at(row, col).getMapped
	}
	
	setMapped { arg row, col, val;
		array2D.at(row, col).setMapped(val)
	}
	
	synthID_ { arg id; array2D.do({ arg item; item.synthID = id })  }
	synthID { array2D.at(0, 0).synthID }
	
	modSpecRow { arg row, spec;
		array2D.doRow(row, { arg item;
			item.spec = spec.asControlSpec
		})
	}

}