//Original by Klaus Kessner, modified by Julian Rohrhuber
	+Color{
		*hsv { arg hue, sat, val, alpha=255;
			var h, s, v, r, g, b, rescale,  segment, teil, t1, t2, t3;
			// rescaling function.
			rescale = { arg value, min, max, newmin, newmax;
		        ( ( ((newmax - newmin) / (max - min)) * (value - min) ) + newmin);
			};
		
			h = rescale.value(hue, 0, 255, 0, 360);
			s = rescale.value(sat, 0, 255, 0, 1.0);
			v = rescale.value(val, 0, 255, 0, 1.0);
		
		
				if( s == 0, { r=g=b=v },
						{ segment = floor(h/60);
						teil = ( h/60 - segment );
						t1 = v * (1-s);
						t2 = v * (1 - (s * teil));
						t3 = v * (1 - (s * (1-teil)));
						if( segment == 0, { r=v; g=t3; b=t1 });
						if( segment == 1, { r=t2; g=v; b=t3 });
						if( segment == 2, { r=t1; g=v; b=t3 });
						if( segment == 3, { r=t1; g=t2; b=v });
						if( segment == 4, { r=t3; g=t1; b=v });
						if( segment == 5, { r=v; g=t1; b=t2 });
				}
				);
			r = rescale.value(r, 0, 1, 0, alpha);
			g = rescale.value(g, 0, 1, 0, alpha);
			b = rescale.value(b, 0, 1, 0, alpha);
			//[r, g, b].postln;
			^this.new(r, g, b, alpha);
			}
	}
